# Course Policies for COM580: Web Application Development
Professor [Karl Stolley](http://karlstolley.com), Illinois Institute of Technology, Spring 2011

## Instructor Information
Professor [Karl Stolley](http://karlstolley.com)
karl.stolley@gmail.com
Office: Siegel Hall 208
Office Hours: Monday/Tuesday 3:30-5:30 and by appointment

## Course Description
A production-intensive course in applied theory and practice of developing
web-based applications, emphasizing interface and experience design using HTML5,
CSS3, and the DOM; and backend development using Ruby-based web application
frameworks. Students will learn agile, modular development techniques grounded
in open-source technologies, including Ubuntu Linux, version control (Git),
jQuery, and Ruby on Rails. Note: students should take [COM 530: Standards-Based
Web Design](http://courses.karlstolley.com/530/) or have a solid command of Web
standards (especially XHTML 1.0 Strict and CSS 1 and 2) prior to enrolling in
this course.

## Course Goals
* Develop user interfaces in emerging Web standards, including HTML5 and CSS3
* Develop strong abilities in using JavaScript and jQuery or another JavaScript
  library/framework for manipulating the Document Object Model (DOM)
* Learn and employ agile development methods for front- and back-end design
* Become familiar with Ruby development frameworks and the Model-View-Controller
  (MVC) architecture
* Explore and design for the affordances and constraints of mobile interfaces
* Connect course content to principles and practices in technical communication
  and information architecture
* Apply course concepts and adjust/extend course projects to fit your own
  academic and professional interests

## Books, Materials, and Technology

### Books
* Castledine, Earle and Sharkie, Craig. _jQuery: Novice to Ninja_.
  SitePoint, 2010. ISBN: 978-0980576856
* Cederholm, Dan. _CSS3 for Web Designers_. A Book Apart, 2010.
  ISBN: 978-0984442522
* Keith, Jeremy. _DOM Scripting: Web Design with JavaScript and
  the Document Object Model_. Friends of ED, 2005. ISBN: 978-1590595336
* Keith, Jeremy. _HTML5 for Web Designers_. A Book Apart, 2010.
  ISBN: 978-0984442508
* Ruby, Sam. _Agile Web Development with Rails_, 4th Ed.
  Pragmatic Bookshelf, 2010. ISBN: 978-1-93435-654-8
* Swicegood, Travis. _Pragmatic Guide to Git_. Pragmatic Bookshelf, 2011.
  ISBN: 978-1-93435-654-8
* Thomas, Dave, with Fowler, Chad and Hunt, Andy. (2009). _Programming Ruby 1.9:
  The Pragmatic Programmers' Guide_, 3rd Ed. Pragmatic Bookshelf, 2009.
  ISBN: 978-1-93435-608-1

### Required Materials and Technology
* A computer running Mac OS X Snow Leopard or better; or Ubuntu Linux or another
  distributions of Linux/Unix (No Windows, no exceptions.)
* A [GitHub](http://github.com) account (free/public or pay/private)
* A private/public DSA key pair on each computer you use
* A Twitter account (we'll be working with the Twitter API)
* A Google account (for Gmail, Google Groups, etc.)
* Some kind of sketchbook (paper or digital)

### Recommended Materials and Technology
* A [Diigo](http://diigo.com/) or other social bookmarking account
* A mobile device running Android or iOS (iPod Touch, iPhone, or iPad)
* An iOS Developer Program Membership (if you have a Mac and iOS device)

## Course Projects, Grading, and Policies

### Course Projects
See descriptions in the Course Projects document, `projects.md`.

### Grading
Project 1: 20pts
Project 2: 30pts
Class Participation: 50pts
TOTAL: 100pts

A = 90+ pts; B= 80-89pts; C=70-79pts; E =< 69 pts

### Grading Criteria
* A - Student has turned in all required components of a project, the work is
  exceptional in quality, and reflects the student's dedication to adjusting the
  project to his or her own interests.
* B - Student has turned in all required components of a project and submitted
  work that is acceptable as graduate level.
* C - Student has turned in all required components of a project, but the work
  is below graduate level.
* E - Student has not turned in all required components of a project.

### Attendance and Participation
Your attendance and active participation are required both for your own success
in the class, and for the success of the class as a whole. However, if you
absolutely must miss, please contact me ahead of time via email.

### Academic Honesty
As with any course at IIT, you are expected to uphold the Code of Academic
Honesty (p. 48 of the IIT Graduate Bulletin 2010-2012). All work for this course
should be your own original effort, including print and digital page design and
computer code. Summarizations and quotations of text, as well as any use of
open-source code libraries and images not of your own making, should be clearly
cited as legally and ethically warranted and rhetorically appropriate.

If you are at all uncertain as to whether you are submitting work that in whole
or in part may violate the Code of Academic Honesty, please contact me
immediately and before the work is due. The consequences of academic dishonesty
are severe. Any student who violates the Code of Academic Honesty will be
subject to expulsion from this course with a failing grade, and I will report
the student to the Chair of the Department of Humanities and the Associate Dean
of Graduate Academic Affairs, who may take additional disciplinary action.

### Special Needs Statement
Reasonable accommodations will be made for students with documented
disabilities. In order to receive accommodations, students must obtain a letter
of accommodation from the Center for Disability Resources. The Center for
Disability Resources (CDR) is located in Life Sciences Room 218. Contact the
Center by telephone at 312-567-5744 or via email at disabilities@iit.edu

Students who have any difficulty (either permanent or temporary) that might
affect their ability to perform in class should contact me privately, either in
person or via email, at the start of the semester. Methods, materials, or
deadlines will be adapted as required to ensure equitable participation.

## License
Course materials by [Karl Stolley](http://karlstolley.com). Licensed under a
[Creative Commons Attribution 3.0 United States
License](http://creativecommons.org/licenses/by/3.0/us/).
