# Course Projects for COM580: Web Application Development
Professor [Karl Stolley](http://karlstolley.com), Illinois Institute of Technology, Spring 2011

### Project 1 (Due 2/14/11): Rich UX Interface Design

For this project, you will build the front end/user interface as a
prototype-based proposal for a Web application. It should make use of HTML5 and
jQuery, and perhaps CSS3 on the “experience layer” (Cederholm).

#### Project 1 Deliverables
  * A GitHub Repository showcasing your work from start to finish, featuring frequent, well-crafted commits
  * Weekly tags in GitHub marking your progress on the project
  * The finished prototype, either posted to the Web or in test-ready download form from GitHub, tagged with ‘final-prototype’
  * Weekly in-progress presentations/demonstrations (on 1/24, 1/31, and 2/7)
  * Final presentation on 2/14

Note: The Web Applications that will make up the team projects from project two will be chosen from
the prototype/proposals in project one. So be awesome.

### Project 2 (Due 5/2/11): Ruby on Rails Web Application

In Project 2, you will work in teams to develop a functional Web application using the Ruby on Rails
web development framework. Your app can be based on one of your team members’ Project 1, or an
entirely new idea generated by the team. You should follow the guidance in _Getting Real_ and _Agile Development with Rails_ where it would help you, and ignore it where it won’t.

#### Project 1 Deliverables
  * Your app, built using Rails 3 and Ruby 1.9.2, and deployed at Heroku or another Rails-friendly hosting service or server (databases, etc. are up to you)
  * A GitHub Repository that tracks your work from start to finish, featuring frequent, well-crafted commits--and that you use to keep up-to-date with the rest of your team members
  * Test cases for all features
  * Weekly tags in GitHub marking your progress on the project
  * Weekly in-progress presentations/demonstrations (on 3/8, 3/21, 3/28, and 4/4)
  * Final presentation on 4/11


This project will not be a part of the Spring 2011 course; it’s preserved here for future reference:

### Project 3 (Due Week of 5/2/11): Mobile Interface Design

For Project 3, you will focus primarily on a mobile interface for your app developed in project two.
However, you are encouraged to continue to improve the functionality and refine the features of the
app as delivered for project two.

#### Project 3 Deliverables

  * Sketches and prototypes of the interface development
  * Your app with a mobile-friendly interface, preferably using the same URL as the main app
  * A final memo detailing your use of